; File: "interface.scm"

(define (loop)
  (let ((c (getchar)))
    (if (= c #\s)
        (let ((c (getchar)))
          (if (and (>= c #\1)
                   (<= c #\3))
              (sensor (- c #\0))
              (err)))
        (if (= c #\f)
            (let ((c (getchar)))
              (if (and (>= c #\1)
                       (<= c #\2))
                  (forward (- c #\0))
                  (err)))
            (if (= c #\b)
                (let ((c (getchar)))
                  (if (and (>= c #\1)
                           (<= c #\2))
                      (backward (- c #\0))
                      (err)))
                (if (= c #\z)
                    (let ((c (getchar)))
                      (if (and (>= c #\1)
                               (<= c #\2))
                          (zero (- c #\0))
                          (err)))
                    (if (= c #\l)
                        (let ((c (getchar)))
                          (if (and (>= c #\1)
                                   (<= c #\3))
                              (low (- c #\0))
                              (err)))
                        (if (= c #\h)
                            (let ((c (getchar)))
                              (if (and (>= c #\1)
                                       (<= c #\3))
                                  (high (- c #\0))
                                  (err)))
                            (if (= c #\c)
                                (let ((c (getchar)))
                                  (if (and (>= c #\0)
                                           (<= c #\1))
                                      (color (- c #\0))
                                      (err)))
                                (if (= c #\r)
                                    (let ((c (getchar)))
                                      (if (and (>= c #\0)
                                               (<= c #\9))
                                          (ring (- c #\0))
                                          (err)))
                                    (err))))))))))
  (loop))

(define (sensor x)
  (pp (adc x)))

(define (forward x)
  (motor x 100))

(define (backward x)
  (motor x -100))

(define (zero x)
  (motor x 0))

(define (low x)
  (led x 0 100))

(define (high x)
  (led x 100 100))

(define (color x)
  (led2-color (if (= x 0) 'green 'red)))

(define (ring x)
  (if (= x 0)
      (beep 1 0)
      (beep x 1000)))

(define (err)
  (display "error\n"))

(led 2 0 100)

(loop)
