;;; File: "ex1-c.scm"

(define g 1) ;; index du moteur de gauche
(define d 2) ;; index du moteur de gauche
(define puissance 50) ;; puissance envoyee aux moteurs

;;; (avancer m) fait avancer le moteur m.

(define avancer
  (lambda (m)
    (motor m puissance)))

;;; (reculer m) fait reculer le moteur m.

(define reculer
  (lambda (m)
    (motor m (- puissance))))

;;; (stop m) arrete le mouvement du moteur m.

(define stop
  (lambda (m)
    (motor m 0)))

;;; Debut des actions:

(avancer g)
(reculer d)
(sleep 3000) ;; attendre 3 secondes
(stop g)
(stop d)
